public class LinkedList<E> implements List<E> {
	private class Link {
		private E elt;
		private Link next = null;
		private Link(E e) {
			elt = e;
		}
	}
	
	private Link first = null;
	private Link last;
	
	public LinkedList() {
	}
	
	public void add(E e) {
		Link l = new Link(e);
		if (first == null) {
			first = l;
			last = l;
		} else {
			last.next = l;
			last = l;
		}
	}

	public E get(int index) {
	  // antar att index är tillåten (>= 0 , < size)
		Link cur = first;
		while (index > 0) {
			cur = cur.next;
			index--;
		}
		return cur.elt;
	}
	
	public void remove(int index) {
	  // antar att index är tillåten (>= 0 , < size)
		if (index == 0) {
			first = first.next;
		} else {
			Link cur = first;
			Link prev = null;
			while (index > 0) {
				prev = cur;
				cur = cur.next;
				index--;
			}
			prev.next = cur.next;
			if (cur.next == null) {
				last = prev;
			}
		}
		
	}
}
